Calendar

- Main Page
- Related Pages
- Modules
- Data Structures
- Files
- Examples

Macros | Typedefs | Enumerations | Functions
Calendar
Elementary

## Macros
#define | ELM_CALENDAR_CLASS elm_calendar_class_get()
| Calendar widget.
#define | ELM_CALENDAR_EVENT_CHANGED (&(_ELM_CALENDAR_EVENT_CHANGED))
| Emitted when the date in the calendar is changed.
#define | ELM_CALENDAR_EVENT_DISPLAY_CHANGED (&(_ELM_CALENDAR_EVENT_DISPLAY_CHANGED))
| Emitted when the current month displayed in the calendar is changed.

## Typedefs
typedef char *(* | Elm_Calendar_Format_Cb) (struct tm *stime)
| This callback type is used to format the string that will be used to display month and year.
typedef struct _Elm_Calendar_Mark | Elm_Calendar_Mark
| Item handle for a calendar mark.
typedef struct _Elm_Calendar_Mark | Elm_Calendar_Mark
| Item handle for a calendar mark.

## Enumerations
enum | Elm_Calendar_Weekday { ELM_DAY_SUNDAY = 0 , ELM_DAY_MONDAY , ELM_DAY_TUESDAY , ELM_DAY_WEDNESDAY , ELM_DAY_THURSDAY , ELM_DAY_FRIDAY , ELM_DAY_SATURDAY , ELM_DAY_LAST , ELM_DAY_SUNDAY = 0 , ELM_DAY_MONDAY , ELM_DAY_TUESDAY , ELM_DAY_WEDNESDAY , ELM_DAY_THURSDAY , ELM_DAY_FRIDAY , ELM_DAY_SATURDAY , ELM_DAY_LAST }
| A weekday. More...
enum | Elm_Calendar_Selectable { ELM_CALENDAR_SELECTABLE_NONE = 0 , ELM_CALENDAR_SELECTABLE_YEAR = 1 , ELM_CALENDAR_SELECTABLE_MONTH = 2 , ELM_CALENDAR_SELECTABLE_DAY = 4 , ELM_CALENDAR_SELECTABLE_NONE = 0 , ELM_CALENDAR_SELECTABLE_YEAR = 1 , ELM_CALENDAR_SELECTABLE_MONTH = 2 , ELM_CALENDAR_SELECTABLE_DAY = 4 }
| A bitmask used to define which fields of a `tm` struct will be taken into account, when elm_calendar_selected_time_set() is invoked. More...
enum | Elm_Calendar_Weekday { ELM_DAY_SUNDAY = 0 , ELM_DAY_MONDAY , ELM_DAY_TUESDAY , ELM_DAY_WEDNESDAY , ELM_DAY_THURSDAY , ELM_DAY_FRIDAY , ELM_DAY_SATURDAY , ELM_DAY_LAST , ELM_DAY_SUNDAY = 0 , ELM_DAY_MONDAY , ELM_DAY_TUESDAY , ELM_DAY_WEDNESDAY , ELM_DAY_THURSDAY , ELM_DAY_FRIDAY , ELM_DAY_SATURDAY , ELM_DAY_LAST }
| A weekday. More...
enum | Elm_Calendar_Selectable { ELM_CALENDAR_SELECTABLE_NONE = 0 , ELM_CALENDAR_SELECTABLE_YEAR = 1 , ELM_CALENDAR_SELECTABLE_MONTH = 2 , ELM_CALENDAR_SELECTABLE_DAY = 4 , ELM_CALENDAR_SELECTABLE_NONE = 0 , ELM_CALENDAR_SELECTABLE_YEAR = 1 , ELM_CALENDAR_SELECTABLE_MONTH = 2 , ELM_CALENDAR_SELECTABLE_DAY = 4 }
| A bitmask used to define which fields of a `tm` struct will be taken into account, when elm_calendar_selected_time_set() is invoked. More...

## Functions
EOAPI void | elm_obj_calendar_first_day_of_week_set (Eo *obj, Elm_Calendar_Weekday day)
| The first day of week to use on calendar widgets'.
EOAPI Elm_Calendar_Weekday | elm_obj_calendar_first_day_of_week_get (const Eo *obj)
| The first day of week to use on calendar widgets'.
EOAPI void | elm_obj_calendar_selectable_set (Eo *obj, Elm_Calendar_Selectable selectable)
| Define which fields of a tm struct will be taken into account, when Elm.Calendar.selected_time.set is invoked.
EOAPI Elm_Calendar_Selectable | elm_obj_calendar_selectable_get (const Eo *obj)
| Define which fields of a tm struct will be taken into account, when Elm.Calendar.selected_time.set is invoked.
EOAPI void | elm_obj_calendar_interval_set (Eo *obj, double interval)
| The interval on time updates for a user mouse button hold on calendar widgets' month/year selection.
EOAPI double | elm_obj_calendar_interval_get (const Eo *obj)
| The interval on time updates for a user mouse button hold on calendar widgets' month/year selection.
EOAPI void | elm_obj_calendar_weekdays_names_set (Eo *obj, const char **weekdays)
| Weekdays names to be displayed by the calendar.
EOAPI const char ** | elm_obj_calendar_weekdays_names_get (const Eo *obj)
| Weekdays names to be displayed by the calendar.
EOAPI void | elm_obj_calendar_select_mode_set (Eo *obj, Elm_Calendar_Select_Mode mode)
| Select day mode to use.
EOAPI Elm_Calendar_Select_Mode | elm_obj_calendar_select_mode_get (const Eo *obj)
| Select day mode to use.
EOAPI void | elm_obj_calendar_format_function_set (Eo *obj, Elm_Calendar_Format_Cb format_function)
| Set a function to format the string that will be used to display month and year;.
EOAPI const Eina_List * | elm_obj_calendar_marks_get (const Eo *obj)
| Get a list of all the calendar marks.
EOAPI void | elm_obj_calendar_date_min_set (Eo *obj, const Efl_Time *min)
| Minimum date on calendar.
EOAPI const Efl_Time * | elm_obj_calendar_date_min_get (const Eo *obj)
| Minimum date on calendar.
EOAPI void | elm_obj_calendar_date_max_set (Eo *obj, const Efl_Time *max)
| Maximum date on calendar.
EOAPI const Efl_Time * | elm_obj_calendar_date_max_get (const Eo *obj)
| Maximum date on calendar.
EOAPI void | elm_obj_calendar_selected_time_set (Eo *obj, Efl_Time *selected_time)
| Set selected date to be highlighted on calendar.
EOAPI Eina_Bool | elm_obj_calendar_selected_time_get (const Eo *obj, Efl_Time *selected_time)
| Get selected date.
EOAPI Elm_Calendar_Mark * | elm_obj_calendar_mark_add (Eo *obj, const char *mark_type, Efl_Time *mark_time, Elm_Calendar_Mark_Repeat_Type repeat)
| Add a new mark to the calendar.
EOAPI void | elm_obj_calendar_mark_del (Eo *obj, Elm_Calendar_Mark *mark)
| Delete mark from the calendar.
EOAPI void | elm_obj_calendar_marks_clear (Eo *obj)
| Remove all calendar's marks.
EOAPI void | elm_obj_calendar_marks_draw (Eo *obj)
| Draw calendar marks.
EOAPI Eina_Bool | elm_obj_calendar_displayed_time_get (const Eo *obj, Efl_Time *displayed_time)
| Get the current time displayed in the widget.
Evas_Object * | elm_calendar_add (Evas_Object *parent)
| Add a new calendar widget to the given parent Elementary (container) object.
EINA_DEPRECATED void | elm_calendar_text_saturday_color_set (Evas_Object *obj, int pos)
| Set a day text color to the same that represents Saturdays.
EINA_DEPRECATED void | elm_calendar_text_sunday_color_set (Evas_Object *obj, int pos)
| Set a day text color to the same that represents Sundays.
EINA_DEPRECATED void | elm_calendar_text_weekday_color_set (Evas_Object *obj, int pos)
| Set a day text color to the same that represents Weekdays.

## Detailed Description

This is a calendar widget. It helps applications to flexibly display a calendar with day of the week, date, year and month. Applications are able to set specific dates to be reported back, when selected, in the smart callbacks of the calendar widget. The API of this widget lets the applications perform other functions, like:

- placing marks on specific dates
- setting the bounds for the calendar (minimum and maximum years)
- setting the day names of the week (e.g. "Thu" or "Thursday")
- setting the year and month format.

This widget inherits from the Layout one, so that all the functions acting on it also work for calendar objects.

This widget emits the following signals, besides the ones sent from Layout :

- `"changed"` - emitted when the date in the calendar is changed.
- `"display,changed"` - emitted when the current month displayed in the calendar is changed.
- `"focused"` - When the calendar has received focus. (since 1.8)
- `"unfocused"` - When the calendar has lost focus. (since 1.8)
- `"language,changed"` - the program's language changed (since 1.9)

Supported elm_object common APIs.

- elm_object_signal_emit
- elm_object_signal_callback_add
- elm_object_signal_callback_del

Here is some sample code using it:

- Calendar - Simple creation.
- Calendar - Layout strings formatting.
- Calendar - Years restrictions.
- Calendar - Days selection.
- Calendar - Signal callback and getters.
- Calendar - Calendar marks.

## Macro Definition Documentation

## ◆ ELM_CALENDAR_CLASS

#define ELM_CALENDAR_CLASS elm_calendar_class_get()

Calendar widget.

It helps applications to flexibly display a calendar with day of the week, date, year and month. Applications are able to set specific dates to be reported back, when selected, in the smart callbacks of the calendar widget.

## ◆ ELM_CALENDAR_EVENT_CHANGED

#define ELM_CALENDAR_EVENT_CHANGED (&(_ELM_CALENDAR_EVENT_CHANGED))

Emitted when the date in the calendar is changed.

## ◆ ELM_CALENDAR_EVENT_DISPLAY_CHANGED

#define ELM_CALENDAR_EVENT_DISPLAY_CHANGED (&(_ELM_CALENDAR_EVENT_DISPLAY_CHANGED))

Emitted when the current month displayed in the calendar is changed.

## Typedef Documentation

## ◆ Elm_Calendar_Format_Cb

typedef char *(* Elm_Calendar_Format_Cb) (struct tm *stime)

This callback type is used to format the string that will be used to display month and year.

Parameters

  stime | Struct representing time.

Returns
  String representing time that will be set to calendar's text.

See also
  elm_calendar_format_function_set()

## ◆ Elm_Calendar_Mark [1/2]

typedef struct _Elm_Calendar_Mark Elm_Calendar_Mark

Item handle for a calendar mark.

Created with elm_obj_calendar_mark_add and deleted with elm_obj_calendar_mark_del.

## ◆ Elm_Calendar_Mark [2/2]

typedef struct _Elm_Calendar_Mark Elm_Calendar_Mark

Item handle for a calendar mark.

Created with elm_calendar_mark_add and deleted with Elm.Calendar.mark_del.

## Enumeration Type Documentation

## ◆ Elm_Calendar_Weekday [1/2]

enum Elm_Calendar_Weekday

A weekday.

See also elm_obj_calendar_first_day_of_week_set.

Enumerator
ELM_DAY_SUNDAY | Sunday weekday.
ELM_DAY_MONDAY | Monday weekday.
ELM_DAY_TUESDAY | Tuesday weekday.
ELM_DAY_WEDNESDAY | Wednesday weekday.
ELM_DAY_THURSDAY | Thursday weekday.
ELM_DAY_FRIDAY | Friday weekday.
ELM_DAY_SATURDAY | Saturday weekday.
ELM_DAY_LAST | Sentinel value to indicate last enum field during iteration.
ELM_DAY_SUNDAY | Sunday weekday.
ELM_DAY_MONDAY | Monday weekday.
ELM_DAY_TUESDAY | Tuesday weekday.
ELM_DAY_WEDNESDAY | Wednesday weekday.
ELM_DAY_THURSDAY | Thursday weekday.
ELM_DAY_FRIDAY | Friday weekday.
ELM_DAY_SATURDAY | Saturday weekday.
ELM_DAY_LAST | Sentinel value to indicate last enum field during iteration.

## ◆ Elm_Calendar_Selectable [1/2]

enum Elm_Calendar_Selectable

A bitmask used to define which fields of a `tm` struct will be taken into account, when elm_calendar_selected_time_set() is invoked.

See also elm_obj_calendar_selectable_set, elm_obj_calendar_selected_time_set.

Since
  1.8

Enumerator
ELM_CALENDAR_SELECTABLE_NONE | Take no field into account.
ELM_CALENDAR_SELECTABLE_YEAR | Take year field into account.
ELM_CALENDAR_SELECTABLE_MONTH | Take month field into account.
ELM_CALENDAR_SELECTABLE_DAY | Take day field into account.
ELM_CALENDAR_SELECTABLE_NONE | Take no field into account.
ELM_CALENDAR_SELECTABLE_YEAR | Take year field into account.
ELM_CALENDAR_SELECTABLE_MONTH | Take month field into account.
ELM_CALENDAR_SELECTABLE_DAY | Take day field into account.

## ◆ Elm_Calendar_Weekday [2/2]

enum Elm_Calendar_Weekday

A weekday.

See also elm_calendar_first_day_of_week_set.

Enumerator
ELM_DAY_SUNDAY | Sunday weekday.
ELM_DAY_MONDAY | Monday weekday.
ELM_DAY_TUESDAY | Tuesday weekday.
ELM_DAY_WEDNESDAY | Wednesday weekday.
ELM_DAY_THURSDAY | Thursday weekday.
ELM_DAY_FRIDAY | Friday weekday.
ELM_DAY_SATURDAY | Saturday weekday.
ELM_DAY_LAST | Sentinel value to indicate last enum field during iteration.
ELM_DAY_SUNDAY | Sunday weekday.
ELM_DAY_MONDAY | Monday weekday.
ELM_DAY_TUESDAY | Tuesday weekday.
ELM_DAY_WEDNESDAY | Wednesday weekday.
ELM_DAY_THURSDAY | Thursday weekday.
ELM_DAY_FRIDAY | Friday weekday.
ELM_DAY_SATURDAY | Saturday weekday.
ELM_DAY_LAST | Sentinel value to indicate last enum field during iteration.

## ◆ Elm_Calendar_Selectable [2/2]

enum Elm_Calendar_Selectable

A bitmask used to define which fields of a `tm` struct will be taken into account, when elm_calendar_selected_time_set() is invoked.

See also elm_calendar_selectable_set, elm_calendar_selected_time_set.

Since
  1.8

Enumerator
ELM_CALENDAR_SELECTABLE_NONE | Take no field into account.
ELM_CALENDAR_SELECTABLE_YEAR | Take year field into account.
ELM_CALENDAR_SELECTABLE_MONTH | Take month field into account.
ELM_CALENDAR_SELECTABLE_DAY | Take day field into account.
ELM_CALENDAR_SELECTABLE_NONE | Take no field into account.
ELM_CALENDAR_SELECTABLE_YEAR | Take year field into account.
ELM_CALENDAR_SELECTABLE_MONTH | Take month field into account.
ELM_CALENDAR_SELECTABLE_DAY | Take day field into account.

## Function Documentation

## ◆ elm_obj_calendar_first_day_of_week_set()

EOAPI void elm_obj_calendar_first_day_of_week_set | ( | Eo * | obj,
|  | Elm_Calendar_Weekday | day
| ) |  |

The first day of week to use on calendar widgets'.

Parameters

  [in] | obj | The object.
  [in] | day | Weekday enum value, see Elm_Calendar_Weekday

## ◆ elm_obj_calendar_first_day_of_week_get()

EOAPI Elm_Calendar_Weekday elm_obj_calendar_first_day_of_week_get | ( | const Eo * | obj | ) |

The first day of week to use on calendar widgets'.

Parameters

  [in] | obj | The object.

Returns
  Weekday enum value, see Elm_Calendar_Weekday

## ◆ elm_obj_calendar_selectable_set()

EOAPI void elm_obj_calendar_selectable_set | ( | Eo * | obj,
|  | Elm_Calendar_Selectable | selectable
| ) |  |

Define which fields of a tm struct will be taken into account, when Elm.Calendar.selected_time.set is invoked.

By Default the bitmask is set to use all fields of a tm struct (year, month and day of the month).

See also elm_obj_calendar_selected_time_set.

Parameters

  [in] | obj | The object.
  [in] | selectable | A bitmask of Elm_Calendar_Selectable

Since
  1.8

## ◆ elm_obj_calendar_selectable_get()

EOAPI Elm_Calendar_Selectable elm_obj_calendar_selectable_get | ( | const Eo * | obj | ) |

Define which fields of a tm struct will be taken into account, when Elm.Calendar.selected_time.set is invoked.

By Default the bitmask is set to use all fields of a tm struct (year, month and day of the month).

See also elm_obj_calendar_selected_time_set.

Parameters

  [in] | obj | The object.

Returns
  A bitmask of Elm_Calendar_Selectable

Since
  1.8

## ◆ elm_obj_calendar_interval_set()

EOAPI void elm_obj_calendar_interval_set | ( | Eo * | obj,
|  | double | interval
| ) |  |

The interval on time updates for a user mouse button hold on calendar widgets' month/year selection.

This interval value is decreased while the user holds the mouse pointer either selecting next or previous month/year.

This helps the user to get to a given month distant from the current one easier/faster, as it will start to change quicker and quicker on mouse button holds.

The calculation for the next change interval value, starting from the one set with this call, is the previous interval divided by 1.05, so it decreases a little bit.

The default starting interval value for automatic changes is 0.85 seconds.

Parameters

  [in] | obj | The object.
  [in] | interval | The (first) interval value in seconds

## ◆ elm_obj_calendar_interval_get()

EOAPI double elm_obj_calendar_interval_get | ( | const Eo * | obj | ) |

The interval on time updates for a user mouse button hold on calendar widgets' month/year selection.

This interval value is decreased while the user holds the mouse pointer either selecting next or previous month/year.

This helps the user to get to a given month distant from the current one easier/faster, as it will start to change quicker and quicker on mouse button holds.

The calculation for the next change interval value, starting from the one set with this call, is the previous interval divided by 1.05, so it decreases a little bit.

The default starting interval value for automatic changes is 0.85 seconds.

Parameters

  [in] | obj | The object.

Returns
  The (first) interval value in seconds

## ◆ elm_obj_calendar_weekdays_names_set()

EOAPI void elm_obj_calendar_weekdays_names_set | ( | Eo * | obj,
|  | const char ** | weekdays
| ) |  |

Weekdays names to be displayed by the calendar.

By default, weekdays abbreviations get from system are displayed: E.g. for an en_US locale: "Sun, Mon, Tue, Wed, Thu, Fri, Sat"

The first string should be related to Sunday, the second to Monday...

See also elm_obj_calendar_weekdays_names_get.

Calendar - Layout strings formatting.. Calendar - Signal callback and getters..

Parameters

  [in] | obj | The object.
  [in] | weekdays | Array of seven strings to be used as weekday names. Warning: It must have 7 elements, or it will access invalid memory. Warning: The strings must be `null` terminated ('\0').

## ◆ elm_obj_calendar_weekdays_names_get()

EOAPI const char ** elm_obj_calendar_weekdays_names_get | ( | const Eo * | obj | ) |

Weekdays names to be displayed by the calendar.

By default, weekdays abbreviations get from system are displayed: E.g. for an en_US locale: "Sun, Mon, Tue, Wed, Thu, Fri, Sat"

The first string should be related to Sunday, the second to Monday...

See also elm_obj_calendar_weekdays_names_get.

Calendar - Layout strings formatting.. Calendar - Signal callback and getters..

Parameters

  [in] | obj | The object.

Returns
  Array of seven strings to be used as weekday names. Warning: It must have 7 elements, or it will access invalid memory. Warning: The strings must be `null` terminated ('\0').

## ◆ elm_obj_calendar_select_mode_set()

EOAPI void elm_obj_calendar_select_mode_set | ( | Eo * | obj,
|  | Elm_Calendar_Select_Mode | mode
| ) |  |

Select day mode to use.

The day selection mode used.

Parameters

  [in] | obj | The object.
  [in] | mode | The select mode to use.

## ◆ elm_obj_calendar_select_mode_get()

EOAPI Elm_Calendar_Select_Mode elm_obj_calendar_select_mode_get | ( | const Eo * | obj | ) |

Select day mode to use.

The day selection mode used.

Parameters

  [in] | obj | The object.

Returns
  The select mode to use.

## ◆ elm_obj_calendar_format_function_set()

EOAPI void elm_obj_calendar_format_function_set | ( | Eo * | obj,
|  | Elm_Calendar_Format_Cb | format_function
| ) |  |

Set a function to format the string that will be used to display month and year;.

By default it uses strftime with "%B %Y" format string. It should allocate the memory that will be used by the string, that will be freed by the widget after usage. A pointer to the string and a pointer to the time struct will be provided.

Calendar - Layout strings formatting..

Parameters

  [in] | obj | The object.
  [in] | format_function | Function to set the month-year string given the selected date.

## ◆ elm_obj_calendar_marks_get()

EOAPI const Eina_List * elm_obj_calendar_marks_get | ( | const Eo * | obj | ) |

Get a list of all the calendar marks.

See also elm_obj_calendar_mark_add, elm_obj_calendar_mark_del(), elm_obj_calendar_marks_clear.

Parameters

  [in] | obj | The object.

Returns
  List with all calendar marks

## ◆ elm_obj_calendar_date_min_set()

EOAPI void elm_obj_calendar_date_min_set | ( | Eo * | obj,
|  | const Efl_Time * | min
| ) |  |

Minimum date on calendar.

See also elm_obj_calendar_date_max_set, elm_obj_calendar_date_max_get

Set minimum date on calendar.

Set the minimum date, changing the displayed month or year if needed. Displayed day also to be disabled if it is smaller than minimum date.

Parameters

  [in] | obj | The object.
  [in] | min | A tm struct to point to minimum date.

Since
  1.19

## ◆ elm_obj_calendar_date_min_get()

EOAPI const Efl_Time * elm_obj_calendar_date_min_get | ( | const Eo * | obj | ) |

Minimum date on calendar.

See also elm_obj_calendar_date_max_set, elm_obj_calendar_date_max_get

Get minimum date.

Default value is 1 JAN,1902.

Parameters

  [in] | obj | The object.

Returns
  A tm struct to point to minimum date.

Since
  1.19

## ◆ elm_obj_calendar_date_max_set()

EOAPI void elm_obj_calendar_date_max_set | ( | Eo * | obj,
|  | const Efl_Time * | max
| ) |  |

Maximum date on calendar.

See also elm_obj_calendar_date_min_set, elm_obj_calendar_date_min_get

Set maximum date on calendar.

Set the maximum date, changing the displayed month or year if needed. Displayed day also to be disabled if it is bigger than maximum date.

Parameters

  [in] | obj | The object.
  [in] | max | A tm struct to point to maximum date.

Since
  1.19

## ◆ elm_obj_calendar_date_max_get()

EOAPI const Efl_Time * elm_obj_calendar_date_max_get | ( | const Eo * | obj | ) |

Maximum date on calendar.

See also elm_obj_calendar_date_min_set, elm_obj_calendar_date_min_get

Get maximum date.

Default maximum year is -1. Default maximum day and month are 31 and DEC.

If the maximum year is a negative value, it will be limited depending on the platform architecture (year 2037 for 32 bits);

Parameters

  [in] | obj | The object.

Returns
  A tm struct to point to maximum date.

Since
  1.19

## ◆ elm_obj_calendar_selected_time_set()

EOAPI void elm_obj_calendar_selected_time_set | ( | Eo * | obj,
|  | Efl_Time * | selected_time
| ) |  |

Set selected date to be highlighted on calendar.

Set the selected date, changing the displayed month if needed. Selected date changes when the user goes to next/previous month or select a day pressing over it on calendar.

See also elm_obj_calendar_selected_time_get.

Calendar - Days selection.

Parameters

  [in] | obj | The object.
  [in] | selected_time | A tm struct to represent the selected date.

## ◆ elm_obj_calendar_selected_time_get()

EOAPI Eina_Bool elm_obj_calendar_selected_time_get | ( | const Eo * | obj,
|  | Efl_Time * | selected_time
| ) |  |

Get selected date.

Get date selected by the user or set by function elm_obj_calendar_selected_time_set(). Selected date changes when the user goes to next/previous month or select a day pressing over it on calendar.

See also elm_obj_calendar_selected_time_get.

Calendar - Signal callback and getters..

Parameters

  [in] | obj | The object.
  [in,out] | selected_time | A tm struct to point to selected date.

Returns
  `true` if the method succeeded, `false` otherwise

## ◆ elm_obj_calendar_mark_add()

EOAPI Elm_Calendar_Mark * elm_obj_calendar_mark_add | ( | Eo * | obj,
|  | const char * | mark_type,
|  | Efl_Time * | mark_time,
|  | Elm_Calendar_Mark_Repeat_Type | repeat
| ) |  |

Add a new mark to the calendar.

Add a mark that will be drawn in the calendar respecting the insertion time and periodicity. It will emit the type as signal to the widget theme. Default theme supports "holiday" and "checked", but it can be extended.

It won't immediately update the calendar, drawing the marks. For this, elm_obj_calendar_marks_draw(). However, when user selects next or previous month calendar forces marks drawn.

Marks created with this method can be deleted with elm_obj_calendar_mark_del().

See also elm_obj_calendar_marks_draw, elm_obj_calendar_mark_del().

Calendar - Calendar marks.

Parameters

  [in] | obj | The object.
  [in] | mark_type | A string used to define the type of mark. It will be emitted to the theme, that should display a related modification on these days representation.
  [in] | mark_time | A time struct to represent the date of inclusion of the mark. For marks that repeats it will just be displayed after the inclusion date in the calendar.
  [in] | repeat | Repeat the event following this periodicity. Can be a unique mark (that don't repeat), daily, weekly, monthly or annually.

Returns
  The newly added calendar mark

## ◆ elm_obj_calendar_mark_del()

EOAPI void elm_obj_calendar_mark_del | ( | Eo * | obj,
|  | Elm_Calendar_Mark * | mark
| ) |  |

Delete mark from the calendar.

If deleting all calendar marks is required, elm_obj_calendar_marks_clear() should be used instead of getting marks list and deleting each one.

See also elm_obj_calendar_mark_add(), elm_obj_calendar_marks_clear().

Parameters

  [in] | obj | The object.
  [in] | mark | The mark to be deleted.

## ◆ elm_obj_calendar_marks_clear()

EOAPI void elm_obj_calendar_marks_clear | ( | Eo * | obj | ) |

Remove all calendar's marks.

See also elm_obj_calendar_mark_add, elm_obj_calendar_mark_del().

Parameters

  [in] | obj | The object.

## ◆ elm_obj_calendar_marks_draw()

EOAPI void elm_obj_calendar_marks_draw | ( | Eo * | obj | ) |

Draw calendar marks.

Should be used after adding, removing or clearing marks. It will go through the entire marks list updating the calendar. If lots of marks will be added, add all the marks and then call this function.

When the month is changed, i.e. user selects next or previous month, marks will be drawn.

See also elm_obj_calendar_mark_add, elm_obj_calendar_mark_del(), elm_obj_calendar_marks_clear.

Calendar - Calendar marks.

Parameters

  [in] | obj | The object.

## ◆ elm_obj_calendar_displayed_time_get()

EOAPI Eina_Bool elm_obj_calendar_displayed_time_get | ( | const Eo * | obj,
|  | Efl_Time * | displayed_time
| ) |  |

Get the current time displayed in the widget.

Parameters

  [in] | obj | The object.
  [in,out] | displayed_time | A tm struct to point to displayed date.

Returns
  `true` if the method succeeded, `false` otherwise

Since
  1.8

## ◆ elm_calendar_add()

Evas_Object * elm_calendar_add | ( | Evas_Object * | parent | ) |

Add a new calendar widget to the given parent Elementary (container) object.

Parameters

  parent | The parent object.

Returns
  a new calendar widget handle or `NULL`, on errors.

This function inserts a new calendar widget on the canvas.

Calendar - Simple creation.

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## ◆ elm_calendar_text_saturday_color_set()

EINA_DEPRECATED void elm_calendar_text_saturday_color_set | ( | Evas_Object * | obj,
|  | int | pos
| ) |  |

Set a day text color to the same that represents Saturdays.

Parameters

  obj | The calendar object.
  pos | The text position. Position is the cell counter, from left to right, up to down. It starts on 0 and ends on 41.

Deprecated:
  use elm_calendar_mark_add() instead like:

struct tm t = { 0, 0, 12, 6, 0, 0, 6, 6, -1 };
elm_calendar_mark_add(obj, "weekend/day1", &t, ELM_CALENDAR_WEEKLY);

See also
  elm_calendar_mark_add()

## ◆ elm_calendar_text_sunday_color_set()

EINA_DEPRECATED void elm_calendar_text_sunday_color_set | ( | Evas_Object * | obj,
|  | int | pos
| ) |  |

Set a day text color to the same that represents Sundays.

Parameters

  obj | The calendar object.
  pos | The text position. Position is the cell counter, from left to right, up to down. It starts on 0 and ends on 41.

Deprecated:
  use elm_calendar_mark_add() instead like:

struct tm t = { 0, 0, 12, 7, 0, 0, 0, 0, -1 };
elm_calendar_mark_add(obj, "weekend/day2", &t, ELM_CALENDAR_WEEKLY);

See also
  elm_calendar_mark_add()

## ◆ elm_calendar_text_weekday_color_set()

EINA_DEPRECATED void elm_calendar_text_weekday_color_set | ( | Evas_Object * | obj,
|  | int | pos
| ) |  |

Set a day text color to the same that represents Weekdays.

Parameters

  obj | The calendar object
  pos | The text position. Position is the cell counter, from left to right, up to down. It starts on 0 and ends on 41.

Deprecated:
  use elm_calendar_mark_add() instead like:

struct tm t = { 0, 0, 12, 1, 0, 0, 0, 0, -1 };
elm_calendar_mark_add(obj, "week", &t, ELM_CALENDAR_WEEKLY); // monday
t.tm_tm_mday++; t.tm_wday++; t.tm_yday++;
elm_calendar_mark_add(obj, "week", &t, ELM_CALENDAR_WEEKLY); // tuesday
t.tm_tm_mday++; t.tm_wday++; t.tm_yday++;
elm_calendar_mark_add(obj, "week", &t, ELM_CALENDAR_WEEKLY); // wednesday
t.tm_tm_mday++; t.tm_wday++; t.tm_yday++;
elm_calendar_mark_add(obj, "week", &t, ELM_CALENDAR_WEEKLY); // thursday
t.tm_tm_mday++; t.tm_wday++; t.tm_yday++;
elm_calendar_mark_add(obj, "week", &t, ELM_CALENDAR_WEEKLY); // friday

See also
  elm_calendar_mark_add()